# pygameutils
PyGame Library additional utils for faster development

#### What it's useful for?

It permits you to develop the games that you like, but faster. :)

#### Current and ongoing features:

- `Camera` class
- `AttachedCamera` class
- `DebugSprite` class
- `TileMaker` class --> Under development
- `CustomMouse` class
- `LimitBox` class --> Under development
- `LimitBoxManager` class --> Under development
- `GUI` class --> Under development
- `Crowd` class --> Under development

#### To install last released version of the library:

Simply open a terminal and type:

```bash
pip install pygameutils
```

If it says that you don't have rights to do that, open a terminal as administrator, on *Windows*, or prefix with `sudo`, on *Linux*.

#### TODO:

- Fix a 'bug' that draws sprites on top of other sprites without layering --> Use Camera layering
- Fix AttachedCamera so that it doesn't need to call keep_attached(sprite) at each frame (but it's not really a big problem, it can be seen as a feature)
- Make TileMaker class who needs a NxM picture and a JSON/DICT-formatted file that represent cutting coordinates (maybe with image scaling too!). It will return a dictionary with all surfaces taken from that image
- Create LimitBox class that is simply a NxM Sprite particular instance with a some custom functions
- Create LimitBoxManager class that has a register of all LimitBox instances and has a function that, giving a sprite, returns in which of the limitboxes it overlaps
- GUI class and derivatives for making UX/UI development easier to make, with custom functions and events
- Crowd class for making a group of sprite to move as one (with moving styles effects)

- - -

This software is under the WTF Public License.
